︠083e2464-c6b3-48d7-95e0-ad010a033f86s︠
#### aby używać tego programu musisz zrobić jedną z dwóch rzeczy:
####     a) zainstalować Sage lokalnie na komputerze (Linux, Windows, Mac OSX) ---> www.sagemath.org
####     b) lub utworzyć konto w chmurze    --->  cloud.sagemath.com
####
#### miłej zabawy!

#### ważna wskazówka: Sage to Python na sterydach,
####                  podręcznik programowania do Pythona może być nieocenioną pomocą




##### rzut monetą.
##### z prawdopodobieństwem 1/2 ta funkcja daje wynik 0,
##### z prawdopodobieństwem 1/2 ta funkcja daje wynik 1.
def two_point():
    return ZZ.random_element(0,2)

#### informacja na przyszlosc!!!
#### w Sage generowanie liczb losowych może być prostsze, niż w Pythonie
###  ZZ.random_element(a,b) generuje 
####     losową liczbę całkowitą z przedziału *jednostronnie domkniętego*  [a,b)

︡e2f6cbd6-fed5-41dd-8d67-fceb5472635e︡{"done":true}{"done":true}︡
︠51d7fada-2fed-4f74-92bd-087254906e29s︠
# przykładowe rzuty "monetą"
[ two_point() for _ in range(5)]
︡aa1d16da-0259-48f3-bb6d-57f43890c568︡{"stdout":"[0, 1, 1, 1, 1]\n"}︡{"done":true}
︠65c22ae8-378d-44c9-93b9-50029a1b2e88s︠
####  generujemy jeden raz dużo rzutów monetą;
####  wszystkie wykresy (z wyjątkiem ostatniego) będą się opierać na tych danych

dlugosc=100000;
random_numbers=[ two_point() for _ in range(dlugosc)]
︡ee4bd035-7dc2-4e86-895a-72b01a6b811c︡{"done":true}
︠7391997a-4c65-46c0-8f73-6db357fe912es︠

probability=0.5

# scale="linear" or "semilogx"
# będziemy używać osi odciętych albo ze skalą liniową albo ze skalą logarytmiczną

# pierwszy wykres przedstawia kumulatywne sumy;
# drugi wykres przedstawia "kumulatywne" średnie;
def mean_plot(n,ymin=None,ymax=None,scale='semilogx',marker='o'):
    sum=0
    pointsMean=[]
    pointsSum=[]
    
    for m in (1..n):
        sum+=random_numbers[m]
        pointsMean.append([m, sum /m])
        pointsSum.append([m,sum])
        
    L1=line(pointsMean,scale=scale,marker=marker)+line([[1,probability],[n,probability]],
                rgbcolor=(0.5,0.5,0.5),scale=scale)

    L1.set_axes_range(ymin=ymin,ymax=ymax)
    
    L2=line(pointsSum,scale=scale,marker=marker)+line([[0,0],[n,probability*n]],rgbcolor=(0.5,0.5,0.5))
    
  
    return [L1,L2]
︡b5e68925-516b-432c-a508-93ab900992a5︡{"done":true}
︠b17598ce-7fd4-4403-a528-ef4a267a4b4cs︠
mean_plot(50,ymin=0,ymax=1,scale='linear',marker="o")[1]
︡90ecd41c-d6e4-4b81-bf67-63832c1e071c︡{"file":{"filename":"/home/user/.sage/temp/project-f47f2bb6-8a22-4533-8812-70738447dfdb/488/tmp_959wbl5e.svg","show":true,"text":null,"uuid":"59ad26b9-3c1d-499d-8ffe-d3b7ed649023"},"once":false}︡{"done":true}
︠17766a39-0aa2-406e-8982-217ce4a7b03fs︠
︡825d8f70-9329-4929-9bf4-aa23e1ad2ed4︡{"done":true}
︠989a00a9-915c-4216-9b3a-ac75eb7d8612s︠
mean_plot(250,ymin=0,ymax=1,scale='linear',marker="")[1]
︡c867d4e5-7379-4362-8405-540df3d9d4e3︡{"file":{"filename":"/home/user/.sage/temp/project-f47f2bb6-8a22-4533-8812-70738447dfdb/488/tmp_7gpv58qj.svg","show":true,"text":null,"uuid":"1c68b14d-25fc-4fef-a959-50cc7d2bb0d8"},"once":false}︡{"done":true}
︠35f7cb62-b74c-4512-835b-24be2fc1dfc9s︠
mean_plot(50,ymin=0,ymax=1,scale='linear')[0]
︡1f6674c9-c030-4fa6-8a7e-74d27ca3e1bb︡{"file":{"filename":"/home/user/.sage/temp/project-f47f2bb6-8a22-4533-8812-70738447dfdb/488/tmp_he6qaqwo.svg","show":true,"text":null,"uuid":"d3f551ef-532a-4a69-88a2-890e08a3208f"},"once":false}︡{"done":true}
︠403e4a4c-3e65-4fe6-8526-03b8d10a0453s︠
mean_plot(250,ymin=0,ymax=1,scale='linear',marker="")[0]
︡38d38ff0-dd3d-440f-a4e6-1da54861f2cd︡{"file":{"filename":"/home/user/.sage/temp/project-f47f2bb6-8a22-4533-8812-70738447dfdb/488/tmp_sxei_19w.svg","show":true,"text":null,"uuid":"46c0697d-74e0-40ae-aad2-3effc2414723"},"once":false}︡{"done":true}
︠695ca5bf-ea09-4234-83b1-47b2dd71122cs︠
mean_plot(dlugosc-1,ymin=0,ymax=1,scale='semilogx',marker='')[0]
︡7506e0cc-c888-44e0-acb2-2389962ec7de︡{"file":{"filename":"/home/user/.sage/temp/project-f47f2bb6-8a22-4533-8812-70738447dfdb/488/tmp_aafdsw_z.svg","show":true,"text":null,"uuid":"8d179db3-db4f-4155-8276-25c8b60f416e"},"once":false}︡{"done":true}
︠51d9072c-a99b-42e3-b361-499009fe47d7s︠
def lots_of_plots(n,m,ymin=None,ymax=None,scale='semilogx',marker='o'):
    
    L1=line([[1,probability],[n,probability]],
                rgbcolor=(0.5,0.5,0.5),scale=scale)
  
    
    
    for iteration in range(m):
        sum=0
        pointsMean=[]
        pointsSum=[]
    
        for m in (1..n):
            sum+=two_point()
            pointsMean.append([m, sum /m])
            pointsSum.append([m,sum])
        
        L1=L1+line(pointsMean,scale=scale,marker=marker,hue=iteration*golden_ratio)


    L1.set_axes_range(ymin=ymin,ymax=ymax)
    return L1




lots_of_plots(100000,10,ymin=0,ymax=1,marker='',scale='semilogx')

︡5d02980c-4f6c-424f-be06-6dc28c2c50de︡{"file":{"filename":"/home/user/.sage/temp/project-f47f2bb6-8a22-4533-8812-70738447dfdb/488/tmp_f87de5xd.svg","show":true,"text":null,"uuid":"0d04c154-c84c-40ac-8559-9c0e8ae574e4"},"once":false}︡{"done":true}
︠e1205bd2-d410-4d1f-b642-88dce0046a8es︠
︡dc03d5f2-4323-444c-a38f-b2186c868b31︡{"done":true}
︠ec3184c6-025e-4a2a-8442-4374ccbb22b0s︠

︡cf251867-cbff-4216-b9a5-07115ae872b7︡{"done":true}
︠0ddabb9d-cfc3-4051-85e4-a828510ed8cds︠
︡36b4e470-9b49-4448-b02b-90f5475c0b40︡{"done":true}
︠ef94f002-7400-452c-8d79-17ed0e18d47cs︠

︡78731bf2-b4a3-479a-9576-4f37891b2c66︡{"done":true}
︠0b4fc8ec-4c17-4c36-bf6b-f56811fd647cs︠

︡dba9b113-dde0-43be-9ad0-5bd9fe69056d︡{"done":true}









